'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _keycode = require('keycode');

var _keycode2 = _interopRequireDefault(_keycode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PERSISTENCE_PREFIX = 'react-pure-ui';

exports.default = function (key, states) {
  return function (Comp) {
    var persistencekey = PERSISTENCE_PREFIX + ':' + key;

    var Pure = function (_Component) {
      _inherits(Pure, _Component);

      function Pure() {
        _classCallCheck(this, Pure);

        var _this = _possibleConstructorReturn(this, (Pure.__proto__ || Object.getPrototypeOf(Pure)).call(this));

        _this.handleKeydown = _this.handleKeydown.bind(_this);

        _this.state = {
          activeState: Number(window.localStorage.getItem(persistencekey)) || 0,
          skip: false
        };
        return _this;
      }

      _createClass(Pure, [{
        key: 'render',
        value: function render() {
          var _state = this.state,
              activeState = _state.activeState,
              skip = _state.skip;

          var props = skip ? this.props : _extends({}, this.props, states[activeState]);
          return _react2.default.createElement(Comp, props);
        }
      }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
          document.addEventListener('keydown', this.handleKeydown);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          document.removeEventListener('keydown', this.handleKeydown);
        }
      }, {
        key: 'handleKeydown',
        value: function handleKeydown(e) {
          var _state2 = this.state,
              activeState = _state2.activeState,
              skip = _state2.skip;

          var key = (0, _keycode2.default)(e);

          if (key === 'left' && states[activeState - 1]) {
            this.changeActiveState(activeState - 1);
          } else if (key === 'right' && states[activeState + 1]) {
            this.changeActiveState(activeState + 1);
          } else if (key === 'esc') {
            this.setState({ skip: !skip });
          }
        }
      }, {
        key: 'changeActiveState',
        value: function changeActiveState(activeState) {
          this.setState({ activeState: activeState });
          window.localStorage.setItem(persistencekey, activeState);
        }
      }]);

      return Pure;
    }(_react.Component);

    Pure.displayName = 'Pure(' + Comp.displayName + ')';

    return Pure;
  };
};